package scraper;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Date;
import java.util.List;
import java.util.Map;

public class Scraper {
	String dir = null;
	public boolean setBaseDir(String dir){
		this.dir = dir;
		return true;
	}
	public boolean saveUrl(String url){
		Date d = new Date();
		Long tm = d.getTime();
		String saveHeaderName = tm+".header";
		String saveName = tm+".html";		
		String[] strs = getContentByUrl(url);
		String saveDir = "";
		if(strs[0].length()>0){
			saveDir = makeDir(url.replace("http://", "/"));
			if(saveDir ==  null){
				return false;
			}
			try {
				saveFile(saveDir,saveHeaderName,strs[0]);
				if(strs[1].length()>0){
					saveFile(saveDir,saveName,strs[1]);
				}				
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
		return true;
	}
	public String[] getContentByUrl(String url){
		String rArr[] = {"",""}; //0번째는 header, 1번째는 content
		System.out.println("START:"+(new Exception()).getStackTrace()[0].getClassName()+"."+(new Exception()).getStackTrace()[0].getMethodName());
		URL u = null;
		try {
			u = new URL(url);
		} catch (MalformedURLException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		HttpURLConnection  huc = null;
		try {
			//String body = "";
			huc = (HttpURLConnection) u.openConnection();
		
			huc.setRequestMethod("GET");
			// inputStream으로 응답 헤더와 메시지를 읽어들이겠다는 옵션을 정의한다.
			huc.setDoInput(true);
			// OutputStream으로 POST 데이터를 넘겨주겠다는 옵션을 정의한다.
			huc.setDoOutput(false);
			// 요청 헤더를 정의한다.( 원래 Content-Length값을 넘겨주어야하는데 넘겨주지 않아도 되는것이 이상하다. )
			huc.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
			// 새로운 OutputStream에 요청할 OutputStream을 넣는다.
			//OutputStream os = huc.getOutputStream();
			// 그리고 write메소드로 메시지로 작성된 파라미터정보를 바이트단위로 "EUC-KR"로 인코딩해서 요청한다.
			// 여기서 중요한 점은 "UTF-8"로 해도 되는데 한글일 경우는 "EUC-KR"로 인코딩해야만 한글이 제대로 전달된다.
			//os.write( body.getBytes("utf-8") );
			// 그리고 스트림의 버퍼를 비워준다.
			//os.flush();
			//System.out.println(huc.getResponseCode());
			
			// 해더 처리
			Map<String, List<String>> map = huc.getHeaderFields();
			//System.out.println("Printing Response Header...\n");
			StringBuffer headerB = new StringBuffer();

			for (Map.Entry<String, List<String>> entry : map.entrySet()) {
				if(entry.getKey() != null){
					headerB.append(entry.getKey());
					headerB.append(": ");
				}
				headerB.append(entry.getValue().toString().replace("[","").replace("]",""));
				headerB.append("\r\n");
			}
			String header = headerB.toString();
			rArr[0] = header;			
			
			InputStream is = huc.getInputStream();
			
			InputStreamReader isr = new InputStreamReader(is);
			BufferedReader br = new BufferedReader(isr );
			//BufferedReader br = new BufferedReader(new FileReader("C:\\VrInfo.log"));
			//BufferedReader br = new BufferedReader(new InputStreamReader (System.in));
			String buf;
			
			StringBuffer contentBf = new StringBuffer();
			// 표준출력으로 한 라인씩 출력
			while( ( buf = br.readLine() ) != null ) {
				contentBf.append(buf);
				contentBf.append("\n");
			}
			// 스트림을 닫는다.
			br.close();
			rArr[1] = contentBf.toString();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return rArr;
	}
	public String makeDir(String dir){
		File DirC = new File(this.dir);
		//System.out.println(DirC.toPath());
		if(!DirC.exists()){
			System.err.println("Not Exists : baseDir");
			return null;
		}
		dir = dir.replace("\\", "/");
		DirC = new File(DirC,dir);
		if(!DirC.exists() && !DirC.mkdirs()){
			System.err.println("폴더생성 에러");
		}
		return DirC.toString();
	}
	public boolean saveFile(String dir,String fileName,String cont) throws IOException {
		File fc = new File(dir);
		//System.out.println(DirC.toPath());
		if(!fc.exists()){
			System.err.println("Not Exists :saveFile Dir");
			return false;
		}
		fc = new File(fc, fileName);
		FileWriter fw = new FileWriter(fc);
		fw.write(cont);
		fw.flush();
		fw.close();
		System.out.println("Save File : "+fileName);
		return true;		
	}
	
}
